<?php
/*  
2023.4.2 Weather data from darksky.net (by Apple) stoppped services 
from version:20190313

Use:  https://www.visualcrossing.com/
Sign up: dayang@dajiguang.com tgYy1hs!$
 
 https://www.wunderground.com/about/data
 https://darksky.net/dev/docs#forecast-request
 sample: 
https://api.darksky.net/forecast/bc312f230c601d4db0414f1c3047177d/49.284,-123.16?extend=hourly&units=si
 Account: dayang@dajiguang.com /PW: tgYy1hs!$
 API secret key:  bc312f230c601d4db0414f1c3047177d
 Up to 1,000 free calls per day 40/hour 
 Update: 1 hour
  ========  
https://openweathermap.org/forecast5
API key: 20a9700fe3788422541beec9a3340dc2
http://api.openweathermap.org/data/2.5/forecast?q=Vancouver,ca&APPID=20a9700fe3788422541beec9a3340dc2
Doc:https://openweathermap.org/forecast5

Up to 60 per minute
Update <2 hours
	it claims "BestForecast" data, update every using 15 minutes, comparing 4 hours of NWS 
	Hourly10day: update in 15min, 
	forecast10day more than 2 hours?
	      (i.e. issue- 9:29 PM File time 10:35pm
		               11:00pm           00:14am)
	   txt_forecast 20 periods with day/night, 
	   simpleforecast: for 7pm every day
	   
	Count clear chance from hourly10day, ( (clear hours)+(Partlyclouds hours/2))/(night hours), 
	Free keys ANVIL PLAN with:
	1.	acwayk / 1@ e03064f9553431f0  dajiguang
	2.  myang67 / 1@ bb71f22b8ef9e074 grandaurora
	Access limit: 500/day  10/minute
*/
/*
Darksky.net icons:
clear-day, clear-night, rain, snow, sleet, wind, fog, cloudy, partly-cloudy-day, or partly-cloudy-night
*/
/* fctcode
1 - Clear 				'sky' 0~29: 20~30 = most sunny/clear, 0~19 clear/sunny
2 - Partially Cloudy 	'sky' 30~59  35 partly cloudy
3 - Mostly Cloudy 		'sky' 60~79
4 - Overcast 			'sky' 80~100	1~4 'sky'=percent of cloud cover
5 - ? 
6 - Fog 
7 - ? 
8 - ? 
9 - ? 
10 - ? 
11 - ? 
12 - Chance of rain 	'sky'=percent of rain
13 - Rain 				'sky'=100
14 - Chance of storms 
15 - Thunderstorms 
16 - ? 
17 - ? 
18 - ? 
19 - Snow Shower 
20 - Chance of snow 
21 - Snow

		"condition": "Clear",
		"icon": "clear",
		"icon_url":"http://icons.wxug.com/i/c/k/clear.gif",
		"fctcode": "1",
		
		"sky": "20",
		"wspd": {"english": "7", "metric": "11"},
		"wdir": {"dir": "SSE", "degrees": "150"},
		"wx": "Mostly Sunny",						//detailed by sky cover
*/
/*

precipIntensity: <1 cloudy/clear
   >0.17~0.38 light snow icon=snow/rain/fog
   0.23 @rain =cloudy
precipType :rain/snow
cloudCover 0-19  clear#0  20-49 Partlyclouds #1  
	>=50, by precipType: rain ->precipIntensity: <0.4mm/h as cloud #2
	
	http://www.theweatherprediction.com/habyhints2/434/ 
		

https://godoc.org/github.com/jtmurphy/darksky

$PrecipTypes = [...]string{
    "rain",
    "snow",
    "sleet",
    "hail",
}
*/

$wCode=[		//'icon'
	"clear-day"		=>	0, 
	"clear-night"		=>	0, 
	"rain"		=>	4, 				//precipIntensity >1
	"snow"		=>	8, 
	"sleet"		=>	8, 
	"wind"		=>	13, 
	"fog"		=>	13, 
	"cloudy"		=>	1, 		//'overcast' >0.95
	"partly-cloudy-day"		=>	1, 				//cloudCover <0.6  
	"partly-cloudy-night"		=>	1,
];
include_once (__DIR__ ."/include/myauroravar.php");

/*
define ("WUURL", 'http://api.wunderground.com/api/' );
define ("KEYAC", 'e03064f9553431f0');
define ("KEYMY", 'bb71f22b8ef9e074');
//define("WUURLD10", 'http://api.wunderground.com/api/bb71f22b8ef9e074/forecast10day/q/');
define("WUURLH10", 'http://api.wunderground.com/api/bb71f22b8ef9e074/hourly10day/q/');
*/
//error define
$wtStatus= [
	"NoErr"		=> 0,
	"JSONfailed" => 1,
	"CopyFailed" => 2,		//failed to get json file
	"updateD10"	=> 0,
	"updateH10"	=> 0,
	"uwkey1"	=> "e03064f9553431f0",
	"uwkey2"	=> "e03064f9553431f0",
	"wuurl"		=> "https://weather.visualcrossing.com/VisualCrossingWebServices/rest/services/timeline/",
	"d10"		=> "forecast10day",
	"h10"		=> "hourly10day",
	"here"		=> "Vancouver",
	"Vancouver" => ["Canada", "Vancouver"],
	"Edmonton"  => ["Canada", "Edmonton"],
	"filepre"	=> " ",
	
];

/* <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<  */
/*  Test, entry updateWeather()

session_start();
if(isset($_SESSION['loc'])) 
	$loc=$_SESSION['loc'];
else 
	$loc="Vancouver";		//vancouver
$timezone=$locinfo[$loc][5];
date_default_timezone_set($timezone);

$csv=array();

updateWeather($loc);
*/

//$fl="weather/VancouverH10.json";
//$fl="http://api.wunderground.com/api/e03064f9553431f0/forecast10day/q/Canada/Vancouver.json";
//$fl=http://api.wunderground.com/api/e03064f9553431f0/hourly10day/q/Canada/Vancouver.json;		//10 day hourly
// 10 day hourly is inaccurate but confusing for big piture of weather. Use 3 only. others use 10day forecast
// 两个数据都使用。每小时读取一次，按fctcode代码保存

 // var_dump $smpfcst['forecastday'][0];

//test
/*
$fcsv=__DIR__ ."/weather/" .$loc. ".csv";
$dat=csv_to_array($fcsv);
$bt=$dat[0]['epoch'];
var_dump ($dat[239]);
echo "<br>". date("Y-m-d H:i:s",$bt);
*/
/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> */

/* --------------------------- Functions ---------------------------------------- */
/* Entry function
allThreeDays.php >>
*/
$csv=array();
function updateWeather($loc){
	global $wtStatus,$fctCode;
	$s=__DIR__ ."/weather/" .$loc;
	$wtStatus['filepre'] =$s;
	//echo $wtStatus['filepre'];
	$wtStatus['here']=$loc;
	$mtime= checkJson($loc);
	$wtStatus["here"]=$loc;
	
//	echo "<br> Last updated: ". date("Y-m-d H:i:s", $mtime); 
}


/*
1. Check and update weather url forecast10day/hourly10day 
2. Update file Country_City_d10.csv / Country_City_h10.csv
*/

/*
*/

function checkJson($loc){
	global $wtStatus, $locinfo;
	$err=0;		//error code

//Hourly10day	
	$mtime=time();
	$wtStatus['updateH10']=1;
//	var_dump ($wtStatus);
	$fld=$wtStatus['filepre'] ."H10.json";	//i.e. VancouverD10.json
	//$wuurl='https://api.darksky.net/forecast/';
	$wuurl='https://weather.visualcrossing.com/VisualCrossingWebServices/rest/services/timeline/';
/*

https://weather.visualcrossing.com/VisualCrossingWebServices/rest/services/timeline/[location]/[date1]/[date2]?key=YOUR_API_KEY 
	//https://www.visualcrossing.com/weather-history/40.7128,-74.0060?unitGroup=us&key=YOUR_API_KEY
*/	
	
	$wuurl .=$locinfo[$loc][2];		//lat
	$wuurl .=',';
	$wuurl .=$locinfo[$loc][3];		//long
	$wuurl .='?include=hours&';
	$wuurl .='unitGroup=metric&key=' .$locinfo[$loc][8];
	if(DBG) echo "<br> loading:  " . $wuurl;
	if(file_exists($fld) && (filesize($fld)>10000) ){
		if (DBG) echo "<br> JSON loaded";
		$mtime=filemtime($fld);		// it's UTC, while windows show local time.
		if(time()<($mtime+10*60)){	//every 10 minutes
//failed will get a json file but lesss then 10KB
			$wtStatus['updateH10']=0;	//skip
			if(DBG) echo "<br> local $fld exist";
		}
		else {
			if(DBG) echo "<br> to be updated $fld";

			$wtStatus['updateH10']=1;
			}
	}
	if($wtStatus['updateH10']){		//reload 
		$fls=$wuurl;	// ."?extend=hourly&units=si&.json";
		echo "\t ...updated";
		if(!copy($fls, $fld)){
			$err |= $wtStatus['CopyFailed']; 
			echo "copy failed <br>";
		}
		if(!file_exists($fld))
			$err |= $wtStatus['JSONfailed']; 
		else
			decodeH10($fld);
	}
	else  {
		echo "\t ...loaded";
		if(DBG) decodeH10($fld);
	}
//	echo "<br>err: $err  H10 @ " .date("H:i:s ", $mtime);	
	return $mtime;		//0 or update time
}
/*
No precipType when precipIntensity=0
Index by cloudCover then precipIntensity

preciptype:
"rain", "snow", "freezingrain"(sleet) "ice(hail)"
*/
$fctCode=array(
	'rain'	=> ['light'=>4,
				'heavy'=>5,
	],
	'snow'	=> ['light'=>8,
				'heavy'=>9,
	],
	'freezingrain'	=> ['light'=>4,
				'heavy'=>5,
	],
	'ice'	=> ['light'=>8,
				'heavy'=>9,
	],

);

function decodeH10($fld){
	global $wtStatus,$fctCode;
	$pType=array("rain", "snow", "freezingrain", "ice");
	$csv=array();
	$json_string = file_get_contents($fld);
	//echo $fld;
  
  $parsed_json = json_decode($json_string,true);
  //if(DBG) var_dump ($parsed_json);
  $hours=array();
  $hour=0;
  foreach($parsed_json["days"] as $key=>$hourData){
		foreach($hourData["hours"] as $key1 => $hours[$hour] ){	
			$hour ++;
		}
		
  }
   if(DBG){ echo "<br><br>"; var_dump ($hours);};
   	/*precipIntensity, snow: 0.2/1/1.6 light S-/moderate S/heavy S+  (https://journals.ametsoc.org/doi/pdf/10.1175/1520-0450%281972%29011%3C0385%3AARBSAA%3E2.0.CO%3B2)
		rain: <2.5 Light <7.6 Moderate <50 heavy  >50 Violent  (Wikki Rain)
		*/

	$txtfcst = $hours;			//next in 168 hours

	for ($i=0; $i<$hour; $i++)
	{
		$dt= $txtfcst[$i];			//next in 168 hours
		//第二维按顺序，不按下标！
		$pi=$dt['precip'];		//in mm, was "precipIntensity"
		if($dt["snow"]>$pi) {	//ignore "snowdepth"(amount in period)
			$pi=$dt["snow"];
		}
		$cc=$dt['cloudcover' ]/100;		//cloudCover,percentages
		$icc=round($cc*5,0, PHP_ROUND_HALF_DOWN);
		if($icc>3)	$icc=3;		//0~0.19
			else if($icc<0)	$icc=0;
		
		if($cc<0.2){
			$fct=0;			//clear
		}
		else{
			if($pi>0.2){	
				$pt=$dt['preciptype'][0];		//preciptype
				switch($pt){
					case 'rain':
					//case 'sleet:
						if($pi<2.5) $fct=$fctCode[$pt]['light'];
						else $fct=$fctCode[$pt]['heavy'];
						break;
					case 'snow': 
					//case 'hail':
						if($pi<1) $fct=$fctCode[$pt]['light'];
						else $fct=$fctCode[$pt]['heavy'];
						break;
					default:
						$fct=10;		//unknown ???
						break;
				}
				
			}
			else{			//no precipType
				$fct=$icc;		//just cloud, 0,1,2,3
			}
		}
		$csv[$i]['hour']=$i;		
		$csv[$i]['epoch']=$dt['datetimeEpoch'];	// UTC
		$csv[$i]['sky']=$cc;		
		$csv[$i]['icon']=$dt['icon' ];
		$csv[$i]['summary']=$dt['conditions' ];		//was "summary"
		$csv[$i]['fctcode']=$fct;
		
	}
	ArrayToCSV(($wtStatus["filepre"] .".csv"), $csv );

	return ;
	//var_dump ($csv);
}


/* Save array to CSV file
*/
function ArrayToCSV($fp, $arry){
	$fh=fopen($fp, 'w+');	//folder must be pre-created
	
	$keys=array_keys($arry[0]);
	fputcsv($fh, $keys);		//keys as header
//	var_dump($keys);
// Generate CSV data from array
     //write out the data
        foreach ( $arry as $row ) {
                fputcsv($fh, $row);
        }
		fclose($fh);
}

/**
 * Function returns XML string for input associative array. 
 * @param Array $array Input associative array
 * @param String $wrap Wrapping tag
 * @param Boolean $upper To set tags in uppercase
 */
 /*
function array2xml($array, $wrap='ROW0', $upper=true) {
    // set initial value for XML string
    $xml = '';
    // wrap XML with $wrap TAG
    if ($wrap != null) {
        $xml .= "<$wrap>\n";
    }
    // main loop
    foreach ($array as $key=>$value) {
        // set tags in uppercase if needed
        if ($upper == true) {
            $key = strtoupper($key);
        }
        // append to XML string
        $xml .= "<$key>" . htmlspecialchars(trim($value)) . "</$key>";
    }
    // close wrap TAG if needed
    if ($wrap != null) {
        $xml .= "\n</$wrap>\n";
    }
    // return prepared XML string
    return $xml;
}
*/

//var_dump($dat);
/**
* @link http://gist.github.com/385876
*/
function csv_to_array($filename, $delimiter=',')
{
//	echo "<br>CSV:"; 
    if(!file_exists($filename) || !is_readable($filename))
        return FALSE;
//	echo $filename;
    $header = NULL;
    $data = array();
    if (($handle = fopen($filename, 'r')) !== FALSE)
    {
        while (($row = fgetcsv($handle, 1000, $delimiter)) !== FALSE)
		{
			//  With header this scenery. Should put keys to header
            if(!$header)
                $header = $row;
            else
                $data[] = array_combine($header, $row);
        
		//	$data[]=$row;
		}
		
        fclose($handle);
    }
    return $data;
}
/*===========================================================*/

?>
