<?php
//bb71f22b8ef9e074 myang67
//e03064f9553431f0 acwayk
//b757482bdb454c69 Ottawa

//801f97624d994f79 Calgary
	$locinfo=array(
//    					0 ID          1 Name      2 Lat   3 Lon    4 gLat  5 time zone		  6 country    7 WU city                     8 UW key
	"Fairbanks"   => ["Fairbanks",  "Fairbanks",  64.8453, -147.722, 65.5, "America/Anchorage",  "USA",    "/AK/Fairbanks",               "CYRP59Y9E7KY8DWCDDTEKCXB7" /*Fairbanks*/],
	"Whitehorse"  => ["Whitehorse", "Whitehorse", 60.72,  -135.06, 63.8, "America/Whitehorse", "Canada", "/Yukon_Territory/Whitehorse", "CYRP59Y9E7KY8DWCDDTEKCXB7" /*Whitehorse*/],
	"Yellowknife" => ["Yellowknife","Yellowknife",62.471, -114.44, 68.6, "America/Yellowknife","Canada", "/Canada/Yellowknife",         "CYRP59Y9E7KY8DWCDDTEKCXB7" /*YN Key1*/],
	"Vancouver"   => ["Vancouver",  "Vancouver",  49.287, -122.94, 54.5, "America/Vancouver",  "Canada", "/British_Columbia/Vancouver", "CYRP59Y9E7KY8DWCDDTEKCXB7" /*Vancouver*/], 
	"Calgary"     => ["Calgary",   "Calgary",     51.05,  -114.07, 57.8, "America/Edmonton",   "Canada", "/Canada/Calgary", "CYRP59Y9E7KY8DWCDDTEKCXB7" /*Calgary*/],
	"Edmonton"    => ["Edmonton",  "Edmonton",    53.541, -113.50, 58.6, "America/Edmonton",   "Canada", "/Canada/Edmonton",            "CYRP59Y9E7KY8DWCDDTEKCXB7" /*YN Key0*/],
	"Regina"      => ["Regina",    "Regina",      50.444, -104.62, 58.1, "America/Regina",     "Canada", "/Canada/Regina",              "CYRP59Y9E7KY8DWCDDTEKCXB7" /*Regina*/],
	"Churchill"   => ["Churchill", "Churchill",   58.751, -94.07,  67.4, "America/Winnipeg",   "Canada", "Manitoba/Churchill",          "CYRP59Y9E7KY8DWCDDTEKCXB7" /*Churchill*/],
	"Winnipeg"    => ["Winnipeg", "Winnipeg",   49.883, -97.149,  58.3, "America/Winnipeg",    "Canada", "Manitoba/Winnipeg",           "CYRP59Y9E7KY8DWCDDTEKCXB7" /*Winnipeg*/],
	"Ottawa"      => ["Ottawa",    "Ottawa",      45.401, -75.7,   54.9, "America/Toronto",    "Canada", "/Ontario/Ottawa",             "CYRP59Y9E7KY8DWCDDTEKCXB7" /*Ottawa*/],
	"Toronto"     => ["Toronto",   "Toronto",     43.683, -79.4,   53.1, "America/Toronto",    "Canada", "/Ontario/Toronto",            "CYRP59Y9E7KY8DWCDDTEKCXB7" /*Toronto*/],
	"Montreal"    => ["Montreal",  "Montreal",    45.5, -73.57,   55.0, "America/Toronto",     "Canada", "/Quebec/Montreal",            "CYRP59Y9E7KY8DWCDDTEKCXB7" /*Montreal*/],
	"Halifax"     => ["Halifax",   "Halifax",     44.65,  -63.58,  54.0, "America/Halifax",    "Canada", "/Nova_Scotia/Halifax",        "CYRP59Y9E7KY8DWCDDTEKCXB7" /*Halifax*/],
	"Reykjavik"   => ["Reykjavik", "Reykjavik",   64.15,  -21.95,  68.8, "UTC",                "Iceland","/IS/Reykjavik",               "CYRP59Y9E7KY8DWCDDTEKCXB7" /*AC*/],
	"Tromso"      => ["Tromso",    "Tromso",      69.65,  18.95,   67.2, "Europe/Oslo",        "Norway", "/NO/Tromso", 					"CYRP59Y9E7KY8DWCDDTEKCXB7" /*Tromso*/], 
	"Inari"       => ["Inari",     "Inari",       68.90,  27.03,   65.3, "Europe/Helsinki",    "Finland","/zmw:00000.1.02827", 			"CYRP59Y9E7KY8DWCDDTEKCXB7" /*Inari*/],
	"Mohe"        => ["Mohe",      "漠河",         52.97,  122.53,  44.0, "Asia/Hong_Kong",     "China",  "/zmw:00000.22.52842", 		"CYRP59Y9E7KY8DWCDDTEKCXB7" /*Mohe*/],		//not confirmed(wrong to Neimenggu)
	"Wulumuqi"    => ["Wulumuqi",  "乌鲁木齐",      43.41,  87.31,   34.0, "Asia/Hong_Kong",     "China",  "/zmw:00000.11.51463", 		"CYRP59Y9E7KY8DWCDDTEKCXB7" /*Wulumuqi*/],		///Xinjiang_Uygur/Urumqi
	"Hobart"	  => ["Hobart",    "Hobart",      -42.88,  147.33, -49.7,"Australia/Hobart",   "Australia",  "/zmw:00000.10.94970", 	"CYRP59Y9E7KY8DWCDDTEKCXB7" /*Hobart*/],		///

	);

// Geomagnetic North Pole position	

$gmnp=[
"1900" => [78.688, 68.792],
"1905" => [78.682, 68.749],
"1910" => [78.661, 68.721],
"1915" => [78.643, 68.569],
"1920" => [78.631, 68.376],
"1925" => [78.628, 68.273],
"1930" => [78.601, 68.260],
"1935" => [78.568, 68.359],
"1940" => [78.540, 68.508],
"1945" => [78.541, 68.531],
"1950" => [78.541, 68.847],
"1955" => [78.536, 69.164],
"1960" => [78.585, 69.467],
"1965" => [78.609, 69.854],
"1970" => [78.655, 70.177],
"1975" => [78.761, 70.470],
"1980" => [78.879, 70.759],
"1985" => [79.046, 70.896],
"1990" => [79.209, 71.127],
"1995" => [79.393, 71.416],
"2000" => [79.612, 71.570],
"2005" => [79.815, 71.805],
"2010" => [80.082, 72.211],
"2011" => [80.140, 72.291],
"2012" => [80.199, 72.373],
"2013" => [80.258, 72.456],
"2014" => [80.316, 72.540],
"2015" => [80.375, 72.625],
"2016" => [80.430, 72.732],
"2017" => [80.484, 72.841],
"2018" => [80.539, 72.950],
"2019" => [80.594, 73.061],
"2020" => [80.648, 73.174],
];

$gmnpyear=[
"1900" ,
"1905" ,
"1910" ,
"1915" ,
"1920" ,
"1925" ,
"1930" ,
"1935" ,
"1940" ,
"1945" ,
"1950" ,
"1955" ,
"1960" ,
"1965" ,
"1970" ,
"1975" ,
"1980" ,
"1985" ,
"1990" ,
"1995" ,
"2000" ,
"2005" ,
"2010" ,
"2011" ,
"2012" ,
"2013" ,
"2014" ,
"2015" ,
"2016" ,
"2017" ,
"2018" ,
"2019" ,
"2020" ,
];

/* ===========================================
  Kp data prepare
*/
$kps=[				//save to kpData.json
	'kp72h' => [],
	'kp45d' => [],
	'kpStatus' =>[],
];

$kpStatus=[
	'kpfile' => "kp/kpToDate.txt",
	'calendarFile' => "kp/AuroraCalendar.png",
	'updateKp'	=> 0,
	'F3'	=>0,
	'G3'	=>0,	
	'F45'	=>0,
	'F27'	=>0,
	
];

$kp72h=[
	'idate' => '',
	'itime' => 0,
	'ftime' => 0,
	'source' => 'F3',
	'kp72h' => ' ',
	'kp72hf' => '',
	'kp72hg' => '',
	'kpmax3d' => '',
];

$kp45d=[
	'idate' => '',
	'itime' => 0,
	'ftime' => 0,
	'source' => 'F45',
	'kp45d' => '45d ',
	'kp45o' => 'original',	//org value
	'kp27o' => 'original'	
] ;
/* Lever colors
*/
$kpcolor=[
 '0'   =>  ['r' => 242, 'g' => 242, 'b' => 242],	// light gray
 '1'   =>  ['r' => 217, 'g' => 217, 'b' => 217],	//gray
 '2'   =>  ['r' => 191, 'g' => 191, 'b' => 191],	//gray
 '3'   =>  ['r' => 000, 'g' => 176, 'b' => 80],	    // green
 '4'   =>  ['r' => 255, 'g' => 192, 'b' => 0],	    // orange
 '5'   =>  ['r' => 255, 'g' => 0,   'b' => 00],	    //red
 '6'   =>  ['r' => 175, 'g' => 0,   'b' => 33],	    // dark red
 '7'   =>  ['r' => 255, 'g' => 40,   'b' => 160],		//purple
 '9'   =>  ['r' => 255, 'g' => 0,   'b' => 255],	//magenta
 '8'   =>  ['r' => 148, 'g' => 0,   'b' => 212],	//violet
 //'9'   =>  ['r' => 234, 'g' => 106,   'b' => 215],		//pink
];
?>
